#ifndef CLASS_DEFINE
struct afunix_source_connection
{
  struct log_handler_pipe super;
  struct afunix_source *afunix;
  int fd;
  struct io_fd *src;
  struct afunix_source_connection *next_connection;
};
extern struct ol_class afunix_source_connection_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afunix_source_connection_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afunix_source_connection *i = (struct afunix_source_connection *) o;
  mark((struct ol_object *) i->afunix);
  mark((struct ol_object *) i->src);
  mark((struct ol_object *) i->next_connection);
}

struct ol_class afunix_source_connection_class =
{ STATIC_HEADER,
  &log_handler_pipe_class, "afunix_source_connection", sizeof(struct afunix_source_connection),
  do_afunix_source_connection_mark,
  NULL
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct afunix_accept_callback
{
  struct fd_listen_callback super;
  struct afunix_source *afunix;
};
extern struct ol_class afunix_accept_callback_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afunix_accept_callback_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afunix_accept_callback *i = (struct afunix_accept_callback *) o;
  mark((struct ol_object *) i->afunix);
}

struct ol_class afunix_accept_callback_class =
{ STATIC_HEADER,
  &fd_listen_callback_class, "afunix_accept_callback", sizeof(struct afunix_accept_callback),
  do_afunix_accept_callback_mark,
  NULL
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct afunix_source
{
  struct log_source_driver super;
  struct io_backend *backend;
  struct io_fd *src;
  struct listen_fd *listen;
  struct resource_list *resources;
  struct ol_string *name;
  int proto;
};
extern struct ol_class afunix_source_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afunix_source_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afunix_source *i = (struct afunix_source *) o;
  mark((struct ol_object *) i->backend);
  mark((struct ol_object *) i->src);
  mark((struct ol_object *) i->listen);
  mark((struct ol_object *) i->resources);
}

static void do_afunix_source_free(struct ol_object *o)
{
  struct afunix_source *i = (struct afunix_source *) o;
  ol_string_free(i->name);
}

struct ol_class afunix_source_class =
{ STATIC_HEADER,
  &log_source_driver_class, "afunix_source", sizeof(struct afunix_source),
  do_afunix_source_mark,
  do_afunix_source_free
};
#endif /* !CLASS_DECLARE */

